/***************************************************************************
 * Artekit STM32 DIY lightsaber audio board
 * Copyright (C) 2013 Artekit Italy
 * Written by Ivan Meleca
 * http://www.artekit.eu
 
### config.h
 
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/
#ifndef __CONFIG_H__
#define __CONFIG_H__

#include "stm32f10x.h"
#include "sys.h"

/* Quantity of available sounds */
#define SND_MAX_DESC	30

/* Sound types */
#define SND_TYPE_HUM	1
#define SND_TYPE_OFF	2
#define SND_TYPE_ON		3
#define SND_TYPE_HIT	4
#define SND_TYPE_STRIKE	5
#define SND_TYPE_SWING	6

/* This structure defines every sound in the serial flash */
typedef TYPEDEF_PRE struct snd_desc_struct
{
	uint8_t type;			/* Type */
	uint32_t offs;			/* Offset in the serial flash */
	uint32_t len;			/* Length in bytes */
} TYPEDEF_POST SND_DESC;

/* This is the descriptor of the sound in the serial flash */
typedef TYPEDEF_PRE struct snd_header_struct
{
	uint16_t ver;			/* Version of the header */
	uint8_t cnt;			/* How many SND_DESC there are in the serial flash */
	uint16_t crc;			/* CRC. We don't use it by now */
} TYPEDEF_POST SND_HEADER;

uint8_t configPoll(void);
void configReceive(void);
uint8_t configLoad(void);

#endif /* __CONFIG_H__ */
