/***************************************************************************
 * Artekit STM32 DIY lightsaber audio board
 * Copyright (C) 2013 Artekit Italy
 * Written by Ivan Meleca
 * http://www.artekit.eu
 
### i2c.h

#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/
#ifndef __I2C_H__
#define __I2C_H__

void i2cInit(uint32_t speed);
uint8_t i2cReadRegister(uint8_t slave, uint8_t reg);
void i2cReadMultipleRegisters(uint8_t* buf, uint8_t slave, uint8_t reg, uint16_t qty);
void i2cWriteRegister(uint8_t slave, uint8_t reg, uint8_t data);
void i2cWrite(uint8_t* buf, uint8_t slave, uint8_t reg, uint16_t qty);
void i2cDeinit(void);

#endif /* __I2C_H__ */
