/***************************************************************************
 * Artekit STM32 DIY lightsaber audio board
 * Copyright (C) 2013 Artekit Italy
 * Written by Ivan Meleca
 * http://www.artekit.eu
 
### sys.h
 
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/
#ifndef	__SYS_H__
#define	__SYS_H__

#if defined(__GNUC__)
#define TYPEDEF_PRE
#define TYPEDEF_POST	__attribute__ ((__packed__))
#else
#define TYPEDEF_PRE __packed
#define TYPEDEF_POST
#endif

#define FLASH_CS_ON()		(GPIOA->BRR = GPIO_Pin_4)
#define FLASH_CS_OFF()		(GPIOA->BSRR = GPIO_Pin_4)
#define DAC_CS_OFF()		(GPIOA->BSRR = GPIO_Pin_2)

uint8_t		sysInitSystickTimer(void);
void		sysDelayMs(uint32_t dly);
void 		sysInitTimer(void);
void		sysStopTimer(void);
void 		sysRCCConfiguration(void);
void		sysConfigGPIO(void);
uint32_t	sysGetTickCount(void);

#endif	/* __SYS_H__ */
